/* util.c generated by valac 0.48.17, the Vala compiler
 * generated from util.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2004-2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
seahorse_util_show_error (GtkWidget* parent,
                          const gchar* heading,
                          const gchar* message)
{
	GtkWindow* window = NULL;
	GtkMessageDialog* dialog = NULL;
	GtkWindow* _tmp2_;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp6_;
	GtkMessageDialog* _tmp7_;
	window = NULL;
	if (message == NULL) {
		message = "";
	}
	if (parent != NULL) {
		if (!G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ())) {
			GtkWidget* _tmp0_;
			_tmp0_ = gtk_widget_get_toplevel (parent);
			parent = _tmp0_;
		}
		if (G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ())) {
			GtkWindow* _tmp1_;
			_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (parent, gtk_window_get_type (), GtkWindow));
			_g_object_unref0 (window);
			window = _tmp1_;
		}
	}
	_tmp2_ = window;
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp2_, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "");
	g_object_ref_sink (_tmp3_);
	dialog = _tmp3_;
	if (heading == NULL) {
		GtkMessageDialog* _tmp4_;
		_tmp4_ = dialog;
		g_object_set ((GObject*) _tmp4_, "text", message, NULL);
	} else {
		GtkMessageDialog* _tmp5_;
		_tmp5_ = dialog;
		g_object_set ((GObject*) _tmp5_, "text", heading, "secondary-text", message, NULL);
	}
	_tmp6_ = dialog;
	gtk_dialog_run ((GtkDialog*) _tmp6_);
	_tmp7_ = dialog;
	gtk_widget_destroy ((GtkWidget*) _tmp7_);
	_g_object_unref0 (dialog);
	_g_object_unref0 (window);
}

gchar*
seahorse_util_get_display_date_string (guint64 time)
{
	GDateTime* created_date = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
	if (time == ((guint64) 0)) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("");
		result = _tmp0_;
		return result;
	}
	_tmp1_ = g_date_time_new_from_unix_utc ((gint64) time);
	created_date = _tmp1_;
	_tmp2_ = created_date;
	_tmp3_ = g_date_time_format (_tmp2_, "%x");
	result = _tmp3_;
	_g_date_time_unref0 (created_date);
	return result;
}

gboolean
seahorse_util_list_store_find (GListStore* store,
                               GObject* item,
                               guint* position)
{
	guint _vala_position = 0U;
	GEqualFunc _tmp0_;
	guint _tmp1_ = 0U;
	gboolean _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (store != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = g_direct_equal;
	_tmp2_ = seahorse_util_list_store_find_with_equal_func (store, item, _tmp0_, &_tmp1_);
	_vala_position = _tmp1_;
	result = _tmp2_;
	if (position) {
		*position = _vala_position;
	}
	return result;
}

gboolean
seahorse_util_list_store_find_with_equal_func (GListStore* store,
                                               GObject* item,
                                               GEqualFunc func,
                                               guint* position)
{
	guint _vala_position = 0U;
	gboolean result = FALSE;
	g_return_val_if_fail (store != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	{
		guint i = 0U;
		i = (guint) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GObject* _tmp2_;
				GObject* _tmp3_;
				gboolean _tmp4_;
				if (!_tmp0_) {
					guint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < g_list_model_get_n_items ((GListModel*) store))) {
					break;
				}
				_tmp2_ = g_list_model_get_item ((GListModel*) store, i);
				_tmp3_ = _tmp2_;
				_tmp4_ = func (_tmp3_, item);
				_g_object_unref0 (_tmp3_);
				if (_tmp4_) {
					if ((&_vala_position) != NULL) {
						_vala_position = i;
					}
					result = TRUE;
					if (position) {
						*position = _vala_position;
					}
					return result;
				}
			}
		}
	}
	result = FALSE;
	if (position) {
		*position = _vala_position;
	}
	return result;
}

